/*
 * 
 * Pin assignments
 * 
 * D0      - MOSFET Pump
 * D1, D2  - I2C
 * D3      - DHT11
 * D4      - PinWIPE
 * D5      - MOSFET Fan
 * D6      - MOSFET Grow LED, PWM
 * D7      - waterlevel (set HIGH to read value)
 * D8      - analog soil moisture (set HIGH to read value) 
 * A0      - analog input for soil moisture and waterlevel readings
 * 
 * D4 and D7 cannot be HIGH at the same time!
 */
 
// D0 is HIGH at boot, no PWM
const uint8_t PinPUMP = D0;
// If D3 is pulled to LOW, boot fails
const uint8_t PINdht = D3;
// D4 is HIGH at boot, boot fail if pulled to LOW
// During Start Screen you can pull D4 to LOW to wipe saved data in EEPROM
// DO NOT PULL D4 DOWN AT WHEN POWERING ON !!! BOOT WILL FAIL
const uint8_t PinWIPE = D4;
const uint8_t PinFAN = D5;
const uint8_t PinLED = D6; //
const uint8_t PINwaterlevel = D7;
const uint8_t PINsoilmoisture = D8;
const uint8_t PINanalog = A0;
