# CanGrow


![CanGrowLogo](Logo/CanGrow_Logo.png)


A simple DIY plant growing system (for cannabis).

![CanGrow_PCB_Front.png](KiCad/CanGrow/CanGrow_PCB_Front_small.png)
![Screenshot_WebUI_root.png](Arduino/CanGrow/Screenshot_WebUI_root.png)

# WORK IN PROGRESS

## Motivation

I want to build a simple grow system, which I can power by my off-grid
12V solar system. So this project is limited to a small 40x40x120 tent
for one plant with a 50W 12V grow LED light.

As I did it for my solar system, the measurements of this project will be shown
on my website. For that a REST API is planned.

I want to automate as much as possible which makes sense and is easy to build.

## Features / ToDo List

- Measure values :white_check_mark:
  - Humidity :white_check_mark:
  - soil moisture :white_check_mark: 
  - temperature :white_check_mark:
  - water level for water tank :white_check_mark:
- LED grow light control (on/off, dimming, max. 12V 50W load ) :white_check_mark:
  - You can of course use a relais as well, if you want to drive 220V lights :white_check_mark:
- fan control (on/off, (PWM?) max 1A) :white_check_mark:
- pump control for automatic watering (max 1A) :large_blue_circle:
- Web UI and REST API for data and controlling :large_blue_circle:
  - simple web ui :white_check_mark:
  - REST API :large_blue_circle:
  - Send notifications with web call (e.g. for mastodon) :red_circle:
  - predefined grow profiles :large_blue_circle:
  - persistend data :white_check_mark:
    - Start of Grow :white_check_mark:
    - day of grow :large_blue_circle:
    - grow profile 
      - watering amount per week :large_blue_circle:
      - light cycle :white_check_mark:
    - wifi settings :white_check_mark:
    - settings in general :white_check_mark:
- Easy to build and use for beginners (i hope so!) :white_check_mark:
  - PCB layout to order from manufacture (jlcpcb or pcbway) :white_check_mark:
  - easy to build up on a perfboard :white_check_mark:
  - easy to etch pcb :white_check_mark:
  - easy to access and modify :white_check_mark:
  - low cost as possible! :white_check_mark:

:white_check_mark: Done - :large_blue_circle: In Progress - :red_circle: ToDo

## Parts used

- ESP8266 D1 mini
- DHT11 humidity and temp sensor
- I2C soil moisture sensor: https://github.com/Miceuz/i2c-moisture-sensor /  https://eu.robotshop.com/de/products/i2c-soil-moisture-sensor
  - the I2C module is for some people too expensive, I plan support for those cheap capacitive sensors: https://www.az-delivery.de/products/bodenfeuchte-sensor-modul-v1-2

- 50W LED 12V full spectrum grow light: https://www.ebay.de/itm/354322466159
- MOSFETS (some i have fyling around, IRF3205, IRF3710, BUZZ11...)
- 12V 4W water pump set https://www.ebay.de/itm/394413649692
